#include <iostream>

using namespace std;

int main() {
	int n, x, y, z, d;
	cin >> n;
	if(n==2)
	{
		cin >> x >> y >> z >> d;
		if(x == z || y == d)
			cout << "1";
		else
			cout << "0";
	}
	else
	{
		for(int i=0; i < 2*n; i++)
		{
			cin>>x;
		}
		cout << "3";
	}
	
	return 0;
}